#!/bin/bash



#1	ColorSort
#2	Elevator 2015
#3	Gyro
#4	Humanoid
#5	Pcar
#6	AirportShuttle
#7	ConvoyCar
#8	Elevator 2017
#9	Parking
#10	Robotic Arm
#11	SimpleVehicle

files=()

#filelist=(SimpleVehicle.csv)


> NE.csv
> A.csv
> C.csv
> NC.csv 

#filelist=(AirportShuttle.csv)
filelist=(ColorSort.csv Elevator2015.csv Gyro.csv HumanoidLTL.csv Pcar.csv AirportShuttle.csv ConvoyCar.csv  Elevator2017.csv   Parking.csv  RoboticArm.csv SimpleVehicle.csv LTLMoP.csv)

TOT=(0 0 0 0 0 0 0 0 0 0 0 0)
NE=(0 0 0 0 0 0 0 0 0 0 0 0)
A=(0 0 0 0 0 0 0 0 0 0 0 0)
C=(0 0 0 0 0 0 0 0 0 0 0 0)
NC=(0 0 0 0 0 0 0 0 0 0 0 0)

fileindex=0
for file in "${filelist[@]}";
do
    vocalDiscussion=0
    notExpressible=0
    
    notAmbigous=0
    ambigous=0
    realNotAmbigous=0
    disagreement=0

    echo "---------------------------------------"
    echo $file
        
    i=0;
    while  read line; do
        
        IFS=",";
        array=($line)
        IFS=$OIFS;
        if [ ${array[0]} != "Mission Requirement" ];
        then
            author1patterns="${array[1]}"
            author2patterns="${array[2]}"

            author1patterns=$(echo $author1patterns | tr -d " " |  tr -d '\n\r' |  tr -d '\n' |  tr -d '\r')
            author2patterns=$(echo $author2patterns | tr -d " " |  tr -d '\n\r' |  tr -d '\n' |  tr -d '\r')

            IFS="&";
            author1patternsarray=($author1patterns)
            author2patternsarray=($author2patterns)
            IFS=$OIFS;

            if [ ${author1patternsarray[0]} == "NE" ] || [ ${author2patternsarray[0]} == "NE" ]; then 
                notExpressible=$(($notExpressible+1))
                echo $line >> NE.csv
            else
                if [ ${author1patternsarray[0]} == "A" ] || [ ${author2patternsarray[0]} == "A" ];
                then
                    ambigous=$(($ambigous+1))
                    echo $line >> A.csv
                else
                    notAmbigous=$(($notAmbigous+1))

                    agreement=true
                    for i in "${author1patternsarray[@]}"
                      do
                        IFS=" ";
                        
                        h=(${i})
                        IFS=$OIFS;
                        found=false
                        
                        for j in "${author2patternsarray[@]}"
                        do
                           IFS=" ";
                            k=(${j})
                            IFS=$OIFS;
                            
                             if [ $k = $h ];
                            then
                                found=true
                            fi
                        done
                        if [ $found = false ]; then
                            agreement=false
                        fi
                    done
                    
                    for i in "${author2patternsarray[@]}"
                      do
                        IFS=" ";
                        h=(${i})
                        IFS=$OIFS;
                        found=false
                        for j in "${author1patternsarray[@]}"
                        do
                        
                            IFS=" ";
                            k=(${j})
                            IFS=$OIFS;
                            if [ $h = $k ];
                            then
                                found=true
                            fi
                        done
                        if [ $found = false ]; then
                            agreement=false
                        fi
                    done
                                    
                   

                   
                    if [ $agreement = true ]; then
                        realNotAmbigous=$(($realNotAmbigous+1))
                        echo $line >> C.csv
                    else
                        #echo $diff
                        disagreement=$(($disagreement+1))
                        echo $line >> NC.csv
                    fi
                fi
            fi
        fi
       
    

    done < $file
   echo "number of not expressible"
   echo $notExpressible   
   
   NE[$fileindex]=$notExpressible
   
   
   echo "number of ambigous"
   echo $ambigous
   A[$fileindex]=$ambigous
      
   echo "Consensus"
   echo $realNotAmbigous
   C[$fileindex]=$realNotAmbigous

   echo "No consensus"
   echo $disagreement
   NC[$fileindex]=$disagreement
   
   TOT[$fileindex]=$(($notExpressible+$ambigous+$realNotAmbigous+$disagreement))
   fileindex=$(($fileindex+1))
   
done

echo "Not expressible"
echo ${NE[@]}
echo "Ambigous"
echo ${A[@]} 
echo "Consensus"
echo ${C[@]}
echo "No consensus"
echo ${NC[@]}
echo "Total per robotic application"
echo ${TOT[@]}

echo "Total number of requirements"
echo $((${TOT[0]}+${TOT[1]}+${TOT[2]}+${TOT[3]}+${TOT[4]}+${TOT[5]}+${TOT[6]}+${TOT[7]}+${TOT[8]}+${TOT[9]}+${TOT[10]}+${TOT[11]}))
echo "Total Spectra"
echo $((${TOT[0]}+${TOT[1]}+${TOT[2]}+${TOT[3]}+${TOT[4]}+${TOT[5]}+${TOT[6]}+${TOT[7]}+${TOT[8]}+${TOT[9]}+${TOT[10]}))

echo "Total not expressible"
totalNE=$((${NE[0]}+${NE[1]}+${NE[2]}+${NE[3]}+${NE[4]}+${NE[5]}+${NE[6]}+${NE[7]}+${NE[8]}+${NE[9]}+${NE[10]}+${NE[11]}))
echo $totalNE


echo "Ambigous"
echo $((${A[0]}+${A[1]}+${A[2]}+${A[3]}+${A[4]}+${A[5]}+${A[6]}+${A[7]}+${A[8]}+${A[9]}+${A[10]}+${A[11]}))

echo "Consensus"
echo $((${C[0]}+${C[1]}+${C[2]}+${C[3]}+${C[4]}+${C[5]}+${C[6]}+${C[7]}+${C[8]}+${C[9]}+${C[10]}+${C[11]}))

echo "No Consensus"
echo $((${NC[0]}+${NC[1]}+${NC[2]}+${NC[3]}+${NC[4]}+${NC[5]}+${NC[6]}+${NC[7]}+${NC[8]}+${NC[9]}+${NC[10]}+${NC[11]}))




