#!/bin/bash



#1	ColorSort
#2	Elevator 2015
#3	Gyro
#4	Humanoid
#5	Pcar
#6	AirportShuttle
#7	ConvoyCar
#8	Elevator 2017
#9	Parking
#10	Robotic Arm
#11	SimpleVehicle

files=()

#filelist=(SimpleVehicle.csv)


> NE.csv
> A.csv
> C.csv
> NC.csv 

#filelist=(AirportShuttle.csv)
filelist=(ColorSort.csv Elevator2015.csv Gyro.csv HumanoidLTL.csv Pcar.csv AirportShuttle.csv ConvoyCar.csv  Elevator2017.csv   Parking.csv  RoboticArm.csv SimpleVehicle.csv LTLMoP.csv)

Visit=0
SequencedVisit=0
OrderedVisit=0
StrictOrderedVisit=0
FairVisit=0
InstantaneousReaction=0
GlobalAvoidance=0
PastAvoidance=0
DelayedReaction=0
Wait=0
FutureAvoidance=0
SequencedVisit=0
StrictOrderedPatrolling=0
OrderedVisit=0
ExactRestricted=0

fileindex=0
for file in "${filelist[@]}";
do
    vocalDiscussion=0
    notExpressible=0
    
    notAmbigous=0
    ambigous=0
    realNotAmbigous=0
    disagreement=0

    echo "---------------------------------------"
    echo $file
        
    i=0;
    while  read line; do
        
        IFS=",";
        array=($line)
        IFS=$OIFS;
        if [ ${array[0]} != "Mission Requirement" ];
        then
            author1patterns="${array[1]}"
            author2patterns="${array[2]}"

            author1patterns=$(echo $author1patterns | tr -d " " |  tr -d '\n\r' |  tr -d '\n' |  tr -d '\r')
            author2patterns=$(echo $author2patterns | tr -d " " |  tr -d '\n\r' |  tr -d '\n' |  tr -d '\r')

            IFS="&";
            author1patternsarray=($author1patterns)
            author2patternsarray=($author2patterns)
            IFS=$OIFS;

            if [ ${author1patternsarray[0]} == "NE" ] || [ ${author2patternsarray[0]} == "NE" ]; then 
                notExpressible=$(($notExpressible+1))
                echo $line >> NE.csv
            else
                if [ ${author1patternsarray[0]} == "A" ] || [ ${author2patternsarray[0]} == "A" ];
                then
                    ambigous=$(($ambigous+1))
                    echo $line >> A.csv
                else
                    notAmbigous=$(($notAmbigous+1))

                    for i in "${author1patternsarray[@]}"
                    do
                        IFS=" ";
                        
                        h=(${i})
                        IFS=$OIFS;
                        found=false
                        
                        if [ $h == "InstantaneousReaction" ]; then
                            InstantaneousReaction=$(($InstantaneousReaction+1))
                        else
                            if [ $h == "Visit" ]; then
                                Visit=$(($Visit+1))
                            else
                                if [ $h == "GlobalAvoidance" ]; then
                                    GlobalAvoidance=$(($GlobalAvoidance+1))
                                else
                                    if [ $h == "PastAvoidance" ]; then
                                        PastAvoidance=$(($PastAvoidance+1))
                                    else
                                        if [ $h == "Patrolling" ]; then
                                            Patrolling=$(($Patrolling+1))
                                        else
                                            if [ $h == "DelayedReaction" ]; then
                                                DelayedReaction=$(($DelayedReaction+1))
                                            else
                                            
                                                if [ $h == "FutureAvoidance" ]; then
                                                FutureAvoidance=$(($FutureAvoidance+1))
                                                  else
                                                    if [ $h == "Wait" ]; then
                                                Wait=$(($Wait+1))
                                                  else
                                                    if [ $h == "SequencedVisit" ]; then
                                              SequencedVisit=$(($SequencedVisit+1))
                                                  else
                                                    
                                                    if [ $h == "StrictOrderedPatrolling" ]; then
                                             
                                                    StrictOrderedPatrolling=$(($StrictOrderedPatrolling+1))
                                                    else
                                                    
                                                    if [ $h == "OrderedVisit" ]; then
                                             
                                                    OrderedVisit=$(($OrderedVisit+1))
                                                    else
                                                    
                                                    if [ $h == "ExactRestricted" ]; then
                                             
                                                    ExactRestricted=$(($ExactRestricted+1))
                                                    else
                                                    echo $h
                                                    fi
                                                    fi
                                                    fi
                                                    fi
                                                    fi
                                                fi
                                            fi
                                        fi
                                    fi
                                fi
                            fi
                        fi
                    done
                        
                fi
            fi
        fi
       
    

    done < $file
   
   NE[$fileindex]=$notExpressible
   
   
   A[$fileindex]=$ambigous
      
   C[$fileindex]=$realNotAmbigous

   NC[$fileindex]=$disagreement
   
   TOT[$fileindex]=$(($notExpressible+$ambigous+$realNotAmbigous+$disagreement))
   fileindex=$(($fileindex+1))
   
done

echo "Visit"
echo $Visit

echo "SequencedVisit"
echo $SequencedVisit

echo "OrderedVisit"
echo $OrderedVisit

echo "StrictOrderedVisit"
echo $StrictOrderedVisit

echo "FairVisit"
echo $FairVisit

echo "InstantaneousReaction"
echo $InstantaneousReaction


echo "GlobalAvoidance"
echo $GlobalAvoidance

echo "PastAvoidance"
echo $PastAvoidance

echo "DelayedReaction"
echo $DelayedReaction

echo "Wait"
echo $Wait

echo "FutureAvoidance"
echo $FutureAvoidance

echo "SequencedVisit"
echo $SequencedVisit

echo "StrictOrderedPatrolling"
echo $StrictOrderedPatrolling

echo "OrderedVisit"
echo $OrderedVisit

echo "ExactRestricted"
echo $ExactRestricted






